$(document).ready(function(){
    $('#searchbox').selectize({
        valueField: 'url',
        labelField: 'name',
        searchField: ['name'],
        maxOptions: 10,
        options: [],
        create: false,
        render: {
            option: function(item, escape) {
                return '<div>'+escape(item.name)+'</div>';
            }
        },
        optgroups: [
            {value: 'product', label: 'Products'},
            {value: 'category', label: 'Categories'},
        ],
        optgroupField: 'class',
        optgroupOrder: ['product','category'],
        load: function(query, callback) {

            $('#search-form').val(query);

            var url = $('#search-url').data('url');

            var cat_id = $('#cat_id').val();

            urlpath = $('#searchbox').data('urlpath');

            $("input[name=search]").val(query);
            $("input[name=q]").val(query);

            if (!query.length) return callback();
            $.ajax({
                url: urlpath,
                type: 'GET',
                dataType: 'json',
                data: {
                    search: query,
                    select_id: cat_id
                },
                error: function() {
                    callback();
                },
                success: function(res) {
                    callback(res.data);
                    console.log(res.data);
                   
                }
            });
        },
        onChange: function(){
            window.location = this.items[0];
        }
    });
});