@extends('inventory.layout') 
@section('title', 'Edit Vehicle Price')
@section('content')
    <!-- push external head elements to head -->
    @push('head')
        <link rel="stylesheet" href="{{ asset('plugins/select2/dist/css/select2.min.css') }}">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/Dropify/0.2.2/css/dropify.css">
        <style type="text/css">
            .gsterror{
                color: red;
            }
            .emailerror{
                color: red;
            }
            .gstverify{
                color: #4b9732;
            }
            .protable{
                overflow-x: auto;
            }
            .image-uploader{
                border: 1px solid #ADB5F8 !important;
            }
        </style>
    @endpush

    
    <div class="container-fluid">
        <div class="page-header">
            <div class="row align-items-end">
                <div class="col-lg-8">
                    <div class="page-header-title">
                        <!-- <i class="ik ik-user-plus bg-blue"></i> -->
                        <div class="d-inline">
                            <h5>{{ __('Edit Vehicle Price')}}</h5>
                            <span>{{ __('Edit Vehicle Price')}}</span>
                        </div>
                    </div>
                </div>
                <div class="col-lg-4">
                    <nav class="breadcrumb-container" aria-label="breadcrumb">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item">
                                <a href="{{url('dashboard')}}"><i class="ik ik-home"></i></a>
                            </li>
                            <li class="breadcrumb-item">
                                <a href="#">{{ __('Edit Vehicle Price')}}</a>
                            </li>
                        </ol>
                    </nav>
                </div>
            </div>
        </div>
        <form class="forms-sample" method="POST" action="{{ route('updateprice',$id) }}" enctype= multipart/form-data id="vehicleform">
        @csrf
        @include('include.message')
        @Method("PUT")

            <div class="row">
                <!-- start message area-->
                
                <!-- end message area-->
                <div class="col-md-12">
                    <div class="card ">
                        <!-- <div class="card-header">
                            <strong><h3>{{ __('Basic Information')}}</h3></strong> 
                        </div>-->
                        <div class="card-body">
                            
                            <div class="row">
                                <div class="col-sm-6">
                                    <div class="form-group">
                                        <label for="last_name">Angebotspreis / Price offer<span class="text-red">*</span></label>
                                        <input id="angebotspreis" type="text" class="form-control" name="angebotspreis" value="" placeholder="Enter Angebotspreis" required="" >

                                    </div>
                                </div>

                                <div class="col-sm-6">
                                    <div class="form-group">
                                        <label for="nachricht">Kommentare / Comments</label>
                                        <textarea id="kommentare" type="text" class="form-control" name="kommentare" ></textarea>

                                    </div>
                                </div>
                                
                            </div>
                            
                           
                        </div>

                        <div class="col-md-12" style="text-align: center;">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-primary">{{ __('Update')}}</button>
                                </div>
                        </div>
                    </div>
                </div>
            </div>


        </form>
    </div>
    <!-- push external js -->
    @push('script') 
    
     
    @endpush
@endsection
