<?php
/**
 * BillingInvoicesSummary
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * BillingInvoicesSummary Class Doc Comment
 *
 * @category    Class
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class BillingInvoicesSummary implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'billingInvoicesSummary';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'billing_invoices' => '\DocuSign\eSign\Model\BillingInvoice[]',
        'past_due_balance' => 'string',
        'payment_allowed' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'billing_invoices' => 'billingInvoices',
        'past_due_balance' => 'pastDueBalance',
        'payment_allowed' => 'paymentAllowed'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'billing_invoices' => 'setBillingInvoices',
        'past_due_balance' => 'setPastDueBalance',
        'payment_allowed' => 'setPaymentAllowed'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'billing_invoices' => 'getBillingInvoices',
        'past_due_balance' => 'getPastDueBalance',
        'payment_allowed' => 'getPaymentAllowed'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['billing_invoices'] = isset($data['billing_invoices']) ? $data['billing_invoices'] : null;
        $this->container['past_due_balance'] = isset($data['past_due_balance']) ? $data['past_due_balance'] : null;
        $this->container['payment_allowed'] = isset($data['payment_allowed']) ? $data['payment_allowed'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets billing_invoices
     * @return \DocuSign\eSign\Model\BillingInvoice[]
     */
    public function getBillingInvoices()
    {
        return $this->container['billing_invoices'];
    }

    /**
     * Sets billing_invoices
     * @param \DocuSign\eSign\Model\BillingInvoice[] $billing_invoices Reserved: TBD
     * @return $this
     */
    public function setBillingInvoices($billing_invoices)
    {
        $this->container['billing_invoices'] = $billing_invoices;

        return $this;
    }

    /**
     * Gets past_due_balance
     * @return string
     */
    public function getPastDueBalance()
    {
        return $this->container['past_due_balance'];
    }

    /**
     * Sets past_due_balance
     * @param string $past_due_balance 
     * @return $this
     */
    public function setPastDueBalance($past_due_balance)
    {
        $this->container['past_due_balance'] = $past_due_balance;

        return $this;
    }

    /**
     * Gets payment_allowed
     * @return string
     */
    public function getPaymentAllowed()
    {
        return $this->container['payment_allowed'];
    }

    /**
     * Sets payment_allowed
     * @param string $payment_allowed 
     * @return $this
     */
    public function setPaymentAllowed($payment_allowed)
    {
        $this->container['payment_allowed'] = $payment_allowed;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


