<?php
/**
 * BrandsResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * BrandsResponse Class Doc Comment
 *
 * @category    Class
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class BrandsResponse implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'brandsResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'brands' => '\DocuSign\eSign\Model\Brand[]',
        'recipient_brand_id_default' => 'string',
        'sender_brand_id_default' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'brands' => 'brands',
        'recipient_brand_id_default' => 'recipientBrandIdDefault',
        'sender_brand_id_default' => 'senderBrandIdDefault'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'brands' => 'setBrands',
        'recipient_brand_id_default' => 'setRecipientBrandIdDefault',
        'sender_brand_id_default' => 'setSenderBrandIdDefault'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'brands' => 'getBrands',
        'recipient_brand_id_default' => 'getRecipientBrandIdDefault',
        'sender_brand_id_default' => 'getSenderBrandIdDefault'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['brands'] = isset($data['brands']) ? $data['brands'] : null;
        $this->container['recipient_brand_id_default'] = isset($data['recipient_brand_id_default']) ? $data['recipient_brand_id_default'] : null;
        $this->container['sender_brand_id_default'] = isset($data['sender_brand_id_default']) ? $data['sender_brand_id_default'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets brands
     * @return \DocuSign\eSign\Model\Brand[]
     */
    public function getBrands()
    {
        return $this->container['brands'];
    }

    /**
     * Sets brands
     * @param \DocuSign\eSign\Model\Brand[] $brands The list of brands.
     * @return $this
     */
    public function setBrands($brands)
    {
        $this->container['brands'] = $brands;

        return $this;
    }

    /**
     * Gets recipient_brand_id_default
     * @return string
     */
    public function getRecipientBrandIdDefault()
    {
        return $this->container['recipient_brand_id_default'];
    }

    /**
     * Sets recipient_brand_id_default
     * @param string $recipient_brand_id_default The brand seen by envelope recipients when a brand is not explicitly set.
     * @return $this
     */
    public function setRecipientBrandIdDefault($recipient_brand_id_default)
    {
        $this->container['recipient_brand_id_default'] = $recipient_brand_id_default;

        return $this;
    }

    /**
     * Gets sender_brand_id_default
     * @return string
     */
    public function getSenderBrandIdDefault()
    {
        return $this->container['sender_brand_id_default'];
    }

    /**
     * Sets sender_brand_id_default
     * @param string $sender_brand_id_default The brand seen by envelope senders when a brand is not explicitly set.
     * @return $this
     */
    public function setSenderBrandIdDefault($sender_brand_id_default)
    {
        $this->container['sender_brand_id_default'] = $sender_brand_id_default;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


