<?php
/**
 * CustomFields
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * CustomFields Class Doc Comment
 *
 * @category    Class
 * @description Contains information about custom fields.
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class CustomFields implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'customFields';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'list_custom_fields' => '\DocuSign\eSign\Model\ListCustomField[]',
        'text_custom_fields' => '\DocuSign\eSign\Model\TextCustomField[]'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'list_custom_fields' => 'listCustomFields',
        'text_custom_fields' => 'textCustomFields'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'list_custom_fields' => 'setListCustomFields',
        'text_custom_fields' => 'setTextCustomFields'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'list_custom_fields' => 'getListCustomFields',
        'text_custom_fields' => 'getTextCustomFields'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['list_custom_fields'] = isset($data['list_custom_fields']) ? $data['list_custom_fields'] : null;
        $this->container['text_custom_fields'] = isset($data['text_custom_fields']) ? $data['text_custom_fields'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets list_custom_fields
     * @return \DocuSign\eSign\Model\ListCustomField[]
     */
    public function getListCustomFields()
    {
        return $this->container['list_custom_fields'];
    }

    /**
     * Sets list_custom_fields
     * @param \DocuSign\eSign\Model\ListCustomField[] $list_custom_fields An array of list custom fields.
     * @return $this
     */
    public function setListCustomFields($list_custom_fields)
    {
        $this->container['list_custom_fields'] = $list_custom_fields;

        return $this;
    }

    /**
     * Gets text_custom_fields
     * @return \DocuSign\eSign\Model\TextCustomField[]
     */
    public function getTextCustomFields()
    {
        return $this->container['text_custom_fields'];
    }

    /**
     * Sets text_custom_fields
     * @param \DocuSign\eSign\Model\TextCustomField[] $text_custom_fields An array of text custom fields.
     * @return $this
     */
    public function setTextCustomFields($text_custom_fields)
    {
        $this->container['text_custom_fields'] = $text_custom_fields;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


