<?php
/**
 * EmailSettings
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * EmailSettings Class Doc Comment
 *
 * @category    Class
 * @description A complex element that allows  the sender to override some envelope email setting information. This can be used to override the Reply To email address and name associated with the envelope and to override the BCC email addresses to which an envelope is sent.   When the emailSettings information is used for an envelope, it only applies to that envelope.   **IMPORTANT**: The emailSettings information is not returned in the GET for envelope status. Use GET /email_settings to return information about the emailSettings.   EmailSettings consists of:   * replyEmailAddressOverride - The Reply To email used for the envelope. DocuSign will verify that a correct email format is used, but does not verify that the email is active. Maximum Length: 100 characters. * replyEmailNameOverride - The name associated with the Reply To email address. Maximum Length: 100 characters. * bccEmailAddresses - An array of up to five email addresses to which the envelope is sent to as a BCC email. Only users with canManageAccount setting set to true can use this option.  DocuSign verifies that the email format is correct, but does not verify that the email is active. Using this overrides the BCC for Email Archive information setting for this envelope. Maximum Length: 100 characters. *Example*: if your account has BCC for Email Archive set up for the email address ‘archive@mycompany.com’ and you send an envelope using the BCC Email Override to send a BCC email to ‘salesarchive@mycompany.com’, then a copy of the envelope is only sent to the ‘salesarchive@mycompany.com’ email address.
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class EmailSettings implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'emailSettings';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'bcc_email_addresses' => '\DocuSign\eSign\Model\BccEmailAddress[]',
        'reply_email_address_override' => 'string',
        'reply_email_name_override' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'bcc_email_addresses' => 'bccEmailAddresses',
        'reply_email_address_override' => 'replyEmailAddressOverride',
        'reply_email_name_override' => 'replyEmailNameOverride'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'bcc_email_addresses' => 'setBccEmailAddresses',
        'reply_email_address_override' => 'setReplyEmailAddressOverride',
        'reply_email_name_override' => 'setReplyEmailNameOverride'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'bcc_email_addresses' => 'getBccEmailAddresses',
        'reply_email_address_override' => 'getReplyEmailAddressOverride',
        'reply_email_name_override' => 'getReplyEmailNameOverride'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['bcc_email_addresses'] = isset($data['bcc_email_addresses']) ? $data['bcc_email_addresses'] : null;
        $this->container['reply_email_address_override'] = isset($data['reply_email_address_override']) ? $data['reply_email_address_override'] : null;
        $this->container['reply_email_name_override'] = isset($data['reply_email_name_override']) ? $data['reply_email_name_override'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets bcc_email_addresses
     * @return \DocuSign\eSign\Model\BccEmailAddress[]
     */
    public function getBccEmailAddresses()
    {
        return $this->container['bcc_email_addresses'];
    }

    /**
     * Sets bcc_email_addresses
     * @param \DocuSign\eSign\Model\BccEmailAddress[] $bcc_email_addresses A list of email addresses that receive a copy of all email communications for an envelope. You can use this for archiving purposes.
     * @return $this
     */
    public function setBccEmailAddresses($bcc_email_addresses)
    {
        $this->container['bcc_email_addresses'] = $bcc_email_addresses;

        return $this;
    }

    /**
     * Gets reply_email_address_override
     * @return string
     */
    public function getReplyEmailAddressOverride()
    {
        return $this->container['reply_email_address_override'];
    }

    /**
     * Sets reply_email_address_override
     * @param string $reply_email_address_override 
     * @return $this
     */
    public function setReplyEmailAddressOverride($reply_email_address_override)
    {
        $this->container['reply_email_address_override'] = $reply_email_address_override;

        return $this;
    }

    /**
     * Gets reply_email_name_override
     * @return string
     */
    public function getReplyEmailNameOverride()
    {
        return $this->container['reply_email_name_override'];
    }

    /**
     * Sets reply_email_name_override
     * @param string $reply_email_name_override 
     * @return $this
     */
    public function setReplyEmailNameOverride($reply_email_name_override)
    {
        $this->container['reply_email_name_override'] = $reply_email_name_override;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


