<?php
/**
 * EventResult
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * EventResult Class Doc Comment
 *
 * @category    Class
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class EventResult implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'eventResult';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'event_timestamp' => 'string',
        'failure_description' => 'string',
        'status' => 'string',
        'vendor_failure_status_code' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'event_timestamp' => 'eventTimestamp',
        'failure_description' => 'failureDescription',
        'status' => 'status',
        'vendor_failure_status_code' => 'vendorFailureStatusCode'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'event_timestamp' => 'setEventTimestamp',
        'failure_description' => 'setFailureDescription',
        'status' => 'setStatus',
        'vendor_failure_status_code' => 'setVendorFailureStatusCode'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'event_timestamp' => 'getEventTimestamp',
        'failure_description' => 'getFailureDescription',
        'status' => 'getStatus',
        'vendor_failure_status_code' => 'getVendorFailureStatusCode'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['event_timestamp'] = isset($data['event_timestamp']) ? $data['event_timestamp'] : null;
        $this->container['failure_description'] = isset($data['failure_description']) ? $data['failure_description'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['vendor_failure_status_code'] = isset($data['vendor_failure_status_code']) ? $data['vendor_failure_status_code'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets event_timestamp
     * @return string
     */
    public function getEventTimestamp()
    {
        return $this->container['event_timestamp'];
    }

    /**
     * Sets event_timestamp
     * @param string $event_timestamp 
     * @return $this
     */
    public function setEventTimestamp($event_timestamp)
    {
        $this->container['event_timestamp'] = $event_timestamp;

        return $this;
    }

    /**
     * Gets failure_description
     * @return string
     */
    public function getFailureDescription()
    {
        return $this->container['failure_description'];
    }

    /**
     * Sets failure_description
     * @param string $failure_description 
     * @return $this
     */
    public function setFailureDescription($failure_description)
    {
        $this->container['failure_description'] = $failure_description;

        return $this;
    }

    /**
     * Gets status
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     * @param string $status Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets vendor_failure_status_code
     * @return string
     */
    public function getVendorFailureStatusCode()
    {
        return $this->container['vendor_failure_status_code'];
    }

    /**
     * Sets vendor_failure_status_code
     * @param string $vendor_failure_status_code 
     * @return $this
     */
    public function setVendorFailureStatusCode($vendor_failure_status_code)
    {
        $this->container['vendor_failure_status_code'] = $vendor_failure_status_code;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


