<?php
/**
 * PostTransactionsRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * PostTransactionsRequest Class Doc Comment
 *
 * @category    Class
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class PostTransactionsRequest implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'postTransactionsRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'document_data' => 'string',
        'dpt_name' => 'string',
        'transaction_name' => 'string',
        'transaction_type_name' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'document_data' => 'documentData',
        'dpt_name' => 'dptName',
        'transaction_name' => 'transactionName',
        'transaction_type_name' => 'transactionTypeName'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'document_data' => 'setDocumentData',
        'dpt_name' => 'setDptName',
        'transaction_name' => 'setTransactionName',
        'transaction_type_name' => 'setTransactionTypeName'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'document_data' => 'getDocumentData',
        'dpt_name' => 'getDptName',
        'transaction_name' => 'getTransactionName',
        'transaction_type_name' => 'getTransactionTypeName'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['document_data'] = isset($data['document_data']) ? $data['document_data'] : null;
        $this->container['dpt_name'] = isset($data['dpt_name']) ? $data['dpt_name'] : null;
        $this->container['transaction_name'] = isset($data['transaction_name']) ? $data['transaction_name'] : null;
        $this->container['transaction_type_name'] = isset($data['transaction_type_name']) ? $data['transaction_type_name'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets document_data
     * @return string
     */
    public function getDocumentData()
    {
        return $this->container['document_data'];
    }

    /**
     * Sets document_data
     * @param string $document_data 
     * @return $this
     */
    public function setDocumentData($document_data)
    {
        $this->container['document_data'] = $document_data;

        return $this;
    }

    /**
     * Gets dpt_name
     * @return string
     */
    public function getDptName()
    {
        return $this->container['dpt_name'];
    }

    /**
     * Sets dpt_name
     * @param string $dpt_name 
     * @return $this
     */
    public function setDptName($dpt_name)
    {
        $this->container['dpt_name'] = $dpt_name;

        return $this;
    }

    /**
     * Gets transaction_name
     * @return string
     */
    public function getTransactionName()
    {
        return $this->container['transaction_name'];
    }

    /**
     * Sets transaction_name
     * @param string $transaction_name 
     * @return $this
     */
    public function setTransactionName($transaction_name)
    {
        $this->container['transaction_name'] = $transaction_name;

        return $this;
    }

    /**
     * Gets transaction_type_name
     * @return string
     */
    public function getTransactionTypeName()
    {
        return $this->container['transaction_type_name'];
    }

    /**
     * Sets transaction_type_name
     * @param string $transaction_type_name 
     * @return $this
     */
    public function setTransactionTypeName($transaction_type_name)
    {
        $this->container['transaction_type_name'] = $transaction_type_name;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


