<?php
/**
 * RecipientSignatureProviderOptions
 *
 * PHP version 5
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;

/**
 * RecipientSignatureProviderOptions Class Doc Comment
 *
 * @category    Class
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class RecipientSignatureProviderOptions implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'recipientSignatureProviderOptions';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'cpf_number' => 'string',
        'one_time_password' => 'string',
        'signer_role' => 'string',
        'sms' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'cpf_number' => 'cpfNumber',
        'one_time_password' => 'oneTimePassword',
        'signer_role' => 'signerRole',
        'sms' => 'sms'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'cpf_number' => 'setCpfNumber',
        'one_time_password' => 'setOneTimePassword',
        'signer_role' => 'setSignerRole',
        'sms' => 'setSms'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'cpf_number' => 'getCpfNumber',
        'one_time_password' => 'getOneTimePassword',
        'signer_role' => 'getSignerRole',
        'sms' => 'getSms'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['cpf_number'] = isset($data['cpf_number']) ? $data['cpf_number'] : null;
        $this->container['one_time_password'] = isset($data['one_time_password']) ? $data['one_time_password'] : null;
        $this->container['signer_role'] = isset($data['signer_role']) ? $data['signer_role'] : null;
        $this->container['sms'] = isset($data['sms']) ? $data['sms'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets cpf_number
     * @return string
     */
    public function getCpfNumber()
    {
        return $this->container['cpf_number'];
    }

    /**
     * Sets cpf_number
     * @param string $cpf_number 
     * @return $this
     */
    public function setCpfNumber($cpf_number)
    {
        $this->container['cpf_number'] = $cpf_number;

        return $this;
    }

    /**
     * Gets one_time_password
     * @return string
     */
    public function getOneTimePassword()
    {
        return $this->container['one_time_password'];
    }

    /**
     * Sets one_time_password
     * @param string $one_time_password 
     * @return $this
     */
    public function setOneTimePassword($one_time_password)
    {
        $this->container['one_time_password'] = $one_time_password;

        return $this;
    }

    /**
     * Gets signer_role
     * @return string
     */
    public function getSignerRole()
    {
        return $this->container['signer_role'];
    }

    /**
     * Sets signer_role
     * @param string $signer_role 
     * @return $this
     */
    public function setSignerRole($signer_role)
    {
        $this->container['signer_role'] = $signer_role;

        return $this;
    }

    /**
     * Gets sms
     * @return string
     */
    public function getSms()
    {
        return $this->container['sms'];
    }

    /**
     * Sets sms
     * @param string $sms 
     * @return $this
     */
    public function setSms($sms)
    {
        $this->container['sms'] = $sms;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\DocuSign\eSign\ObjectSerializer::sanitizeForSerialization($this));
    }
}


